from Object import *

class sample(Object):
#
# init state methods
#
   def initDefault(self):
      print 'Init Default State'
   def initPatrol(self): 
      print 'Init Patrol State'
#
# touch methods
#
   def _touch(self, s):
      print 'I WAS TOUCHED BY ' + s
   def attack(self, s):
      print 'CHARGE TARGET ' + s
# 
# main touch method
#
   def touch(self, ob):
      if self.touchState.has_key(self._state):   # if _state has defined method
         self.touchState[self._state](ob)
      else:
         self.touchState['_default'](ob)
#
# instance class initialization
#
   def __init__(self):
      Object.__init__(self)
   #
   # state method table 
   #
      self.initState['patrol'] = self.initPatrol
   #
   # touch method table
   #
      self.touchState = { 'patrol' : self.attack,
                         '_default' : self._touch }        # state method table

#
# Sample code
#

x = sample()
print '*'*80

x.jump('_default')
x.touch('dragon')
x.jump('patrol')
x.touch('dragon')
